//+------------------------------------------------------------------+
//|                                                  MondayH4Box.mq4 |
//|                                    Modified from WeeklyPivot.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 LimeGreen
#property indicator_color2 OrangeRed
#property indicator_color3 Crimson
#property indicator_color4 Green
#property indicator_color5 Crimson
#property indicator_color6 Green
#property indicator_color7 Crimson
#property indicator_color8 Green
//---- input parameters



//---- buffers
extern int size    = 2 ;

extern double Buff = 20.0;

double Lo1Buffer[];
double Hi1Buffer[];
double Lo2Buffer[];
double Hi2Buffer[];
double Lo3Buffer[];
double Hi3Buffer[];
double Lo4Buffer[];
double Hi4Buffer[];
double Lo1,Hi1,Lo2,Hi2,Lo3,Hi3,Lo4,Hi4;
double H4Low, H4High;
double x;
//string Lo1="Lo1",Hi1="Hi1", Lo2="Lo2";
//string Hi2="Hi2", Lo3="Lo3", Hi4="Hi4", Lo4="Lo4";
//string H4Low="H4Low",H4High="H4High";
int fontsize=8;
int nDigits;


//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   ObjectDelete("Hi1");
   ObjectDelete("Lo1");
   ObjectDelete("Hi2");
   ObjectDelete("Lo2");
   ObjectDelete("Hi3");
   ObjectDelete("Lo3");
   ObjectDelete("Hi4");   
   ObjectDelete("Lo4");

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   
   SetIndexStyle(0,DRAW_ARROW,0,size) ;
   SetIndexArrow(0,160);
   SetIndexStyle(1,DRAW_ARROW,0,size) ;
   SetIndexArrow(1,160);
   SetIndexStyle(2,DRAW_ARROW,0,size) ;
   SetIndexArrow(2,160);
   SetIndexStyle(3,DRAW_ARROW,0,size) ;
   SetIndexArrow(3,160);
   SetIndexStyle(4,DRAW_ARROW,0,size) ;
   SetIndexArrow(4,160);
   SetIndexStyle(5,DRAW_ARROW,0,size) ;
   SetIndexArrow(5,160);
   SetIndexStyle(6,DRAW_ARROW,0,size) ;
   SetIndexArrow(6,160);
   SetIndexStyle(7,DRAW_ARROW,0,size) ;
   SetIndexArrow(7,160);
   
   SetIndexBuffer(0,Lo1Buffer);
   SetIndexBuffer(1,Hi1Buffer);
   SetIndexBuffer(2,Lo2Buffer);
   SetIndexBuffer(3,Hi2Buffer);
   SetIndexBuffer(4,Lo3Buffer);
   SetIndexBuffer(5,Hi3Buffer);
   SetIndexBuffer(6,Lo4Buffer);
   SetIndexBuffer(7,Hi4Buffer);
   
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   SetIndexLabel(5,NULL);
   SetIndexLabel(6,NULL);
   SetIndexLabel(7,NULL);

//---- name for DataWindow and indicator subwindow label
   short_name="1 Box 4";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int counted_bars=IndicatorCounted();

   int limit, i;
   
     
   
//---- indicator calculation

   if(counted_bars<0) return(-1);

   limit=(Bars-counted_bars)-1;

{
   x=Period();
   if (x>240) return(-1);
   if (i==0)
         {
         Print(i);
 /*  
         ObjectCreate("Hi1", OBJ_TEXT, 0, 100, 0);   
         ObjectSetText("Hi1", "                            High " +DoubleToStr(Hi1,4),fontsize,"Arial bold ",Green);
         SetIndexLabel(0, "Hi1");
         ObjectCreate("Lo1", OBJ_TEXT, 0, 100, 0);
         ObjectSetText("Lo1", "                            Low " +DoubleToStr(Lo1,4),fontsize,"Arial bold ",Red);
         SetIndexLabel(1, "Lo1");
*/ 
 
         ObjectCreate("Hi2", OBJ_TEXT, 0, 100, 0);
         ObjectSetText("Hi2", "                            TP1 - " +DoubleToStr(Hi2,4),fontsize,"Arial bold ",Green);
         SetIndexLabel(2, "Hi2");
         ObjectCreate("Lo2", OBJ_TEXT, 0, 100, 0);
         ObjectSetText("Lo2", "                            TP1 - " +DoubleToStr(Lo2,4),fontsize,"Arial bold ",Red);
         SetIndexLabel(3, "Lo2");
         ObjectCreate("Hi3", OBJ_TEXT, 0, 100, 0);
         ObjectSetText("Hi3", "                            TP2 - " +DoubleToStr(Hi3,4),fontsize,"Arial bold ",Green);
         SetIndexLabel(4, "Hi3");
         ObjectCreate("Lo3", OBJ_TEXT, 0, 100, 0);
         ObjectSetText("Lo3", "                            TP2 - " +DoubleToStr(Lo3,4),fontsize,"Arial bold ",Red);
         SetIndexLabel(5, "Lo3");
         ObjectCreate("Hi4", OBJ_TEXT, 0, 100, 0);
         ObjectSetText("Hi4", "                            TP3 - " +DoubleToStr(Hi4,4),fontsize,"Arial bold ",Green);
         SetIndexLabel(6, "Hi4");
         ObjectCreate("Lo4", OBJ_TEXT, 0, 100, 0);
         ObjectSetText("Lo4", "                            TP3 - " +DoubleToStr(Lo4,4),fontsize,"Arial bold ",Red);
         SetIndexLabel(6, "Lo4");
         Print("ObjectSet Done");
         ObjectMove("Hi4", 0, 100,Hi4);
         ObjectMove("Hi3", 0, 100,Hi3);
         ObjectMove("Hi2", 0, 100,Hi2);
         ObjectMove("Hi1", 0, 100,Hi1);
         ObjectMove("Lo1", 0, 100,Lo1);
         ObjectMove("Lo2", 0, 100,Lo2);
         ObjectMove("Lo3", 0, 100,Lo3);
         ObjectMove("Lo4", 0, 100,Lo4);
         Print("ObjectMove Done");
      
         ObjectsRedraw(); 
         Print("ObjectsRedraw Done");
         }
         
}
   if(counted_bars<0) return(-1);


   for (i=limit; i>=0;i--)
   { 

      // Monday
	   if ( 1 == TimeDayOfWeek(Time[i]) && 1 != TimeDayOfWeek(Time[i+1]) )
	   {
		   H4High = iHigh(0,PERIOD_H4,i);
		   H4Low  = iLow(0,PERIOD_H4,i);
      }

      Hi1 = H4High;
      Lo1 = H4Low;
      Hi2 = H4High + ((Hi1+ Buff/100)-(Lo1 - Buff/100))+ Buff/100;
      Lo2 = H4Low - ((Hi1+ Buff/100)-(Lo1 - Buff/100))- Buff/100;
      Hi3 = H4High + 2*((Hi1+ Buff/100)-(Lo1 - Buff/100))+ Buff/100;
      Lo3 = H4Low - 2*((Hi1+ Buff/100)-(Lo1 - Buff/100))- Buff/100; 
      Hi4 = H4High + 3*((Hi1+ Buff/100)-(Lo1 - Buff/100))+ Buff/100;
      Lo4 = H4Low - 3*((Hi1+ Buff/100)-(Lo1 - Buff/100)) - Buff/100; 
      
      
    
      Lo1Buffer[i]=Lo1;
      Hi1Buffer[i]=Hi1;
      Lo2Buffer[i]=Lo2;
      Hi2Buffer[i]=Hi2;
      Lo3Buffer[i]=Lo3;
      Hi3Buffer[i]=Hi3;
      Lo4Buffer[i]=Lo4;
      Hi4Buffer[i]=Hi4;
      
      ObjectMove("Hi1", 0, Time[i],Hi1);
      ObjectMove("Lo1", 0, Time[i],Lo1);
      ObjectMove("Hi2", 0, Time[i],Hi2);
      ObjectMove("Lo2", 0, Time[i],Lo2);
      ObjectMove("Hi3", 0, Time[i],Hi3);
      ObjectMove("Lo3", 0, Time[i],Lo3);
      ObjectMove("Hi4", 0, Time[i],Hi4);
      ObjectMove("Lo4", 0, Time[i],Lo4);
   }









//----
   return(0);
  }
//+------------------------------------------------------------------+