//+------------------------------------------------------------------+
//|                                                  MondayH4Box.mq4 |
//|                                    Modified from WeeklyPivot.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
// #property indicator_buffers 8
//#property indicator_color1 Magenta
//#property indicator_color2 LimeGreen
//#property indicator_color3 DarkOrange
//#property indicator_color4 DodgerBlue
//---- input parameters

//---- buffers

double LoXBuffer[];
double HiXBuffer[];
double LoYBuffer[];
double HiYBuffer[];
double Bh,Bl;

extern double Buff = 20.0;

double LoX,HiX,LoY,HiY,CS,BS;
double H4ALow, H4AHigh;
double x;
//string Lo1="Lo1",Hi1="Hi1", Lo2="Lo2";
//string Hi2="Hi2", Lo3="Lo3", Hi4="Hi4", Lo4="Lo4";
//string H4Low="H4Low",H4High="H4High";
int fontsize=8;
int nDigits;


//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
   ObjectDelete("HiX");
   ObjectDelete("LoX");
   ObjectDelete("HiY");
   ObjectDelete("LoY");
   

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   
//   SetIndexStyle(0,DRAW_ARROW);
//   SetIndexArrow(0,160);
//   SetIndexStyle(1,DRAW_ARROW);
//   SetIndexArrow(1,160);
//   SetIndexStyle(2,DRAW_ARROW);
//   SetIndexArrow(2,160);
//   SetIndexStyle(3,DRAW_ARROW);
//   SetIndexArrow(3,160);
   
//   SetIndexBuffer(0,Lo1Buffer);
//   SetIndexBuffer(1,Hi1Buffer);
//   SetIndexBuffer(2,LoABuffer);
//   SetIndexBuffer(3,HiABuffer);
   
//   SetIndexLabel(0,NULL);
//   SetIndexLabel(1,NULL);
//   SetIndexLabel(2,NULL);
//   SetIndexLabel(3,NULL);

//---- name for DataWindow and indicator subwindow label
   short_name="Box Candle Size";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int counted_bars=IndicatorCounted();

   int limit, i;
   
     
   
//---- indicator calculation

   if(counted_bars<0) return(-1);

   limit=(Bars-counted_bars)-1;

{
   x=Period();
   if (x>240) return(-1);
  if (i==0)
         {
         Print(i);
   
         ObjectCreate("HiX", OBJ_TEXT, 0, 100, 0);   
         ObjectSetText("HiX", "                             (TP4) " +DoubleToStr(HiX,4),fontsize,"Arial bold ",DodgerBlue);
         SetIndexLabel(0, "HiX");
         ObjectCreate("LoX", OBJ_TEXT, 0, 100, 0);
         ObjectSetText("LoX", "                             (TP4) " +DoubleToStr(LoX,4),fontsize,"Arial bold ",DarkOrange);
         SetIndexLabel(1, "LoX");
         
         Print("ObjectSet Done");
         
         ObjectMove("HiX", 0, 100,HiX);
         ObjectMove("LoX", 0, 100,LoX);
        
         
         Print("ObjectMove Done");
      
         ObjectsRedraw(); 
         Print("ObjectsRedraw Done");
         }
         
}
   if(counted_bars<0) return(-1);


   for (i=limit; i>=0;i--)
   { 

      // Monday
	   if ( 1 == TimeDayOfWeek(Time[i]) && 1 != TimeDayOfWeek(Time[i+1]) )
	   {
		   H4AHigh = iHigh(0,PERIOD_H4,i);
		   H4ALow  = iLow(0,PERIOD_H4,i);
      }

      HiX = H4AHigh;
      LoX = H4ALow;
      CS = (H4AHigh - H4ALow)*100;
      Bh = H4AHigh + Buff/100;
      Bl = H4ALow - Buff/100;
      HiY = Bh + 4*(Bh-Bl);
      LoY = Bl - 4*(Bh-Bl);    
      BS = (Bh - Bl)*100;
    
      LoXBuffer[i]=LoX;
      HiXBuffer[i]=HiX;
      LoYBuffer[i]=LoY;
      HiYBuffer[i]=HiY;
      
      ObjectMove("HiX", 0, Time[i],HiX);
      ObjectMove("LoX", 0, Time[i],LoX);
      ObjectMove("HiY", 0, Time[i],HiY);
      ObjectMove("LoY", 0, Time[i],LoY);
      
   }



 Comment( "Box Size =",BS," " ,",  Candle Size =",CS," ",",    Buffer =",Buff," ");




//----
   return(0);
  }
//+------------------------------------------------------------------+